

>module CompileRun (makeRun, createNodes, tag, rang,protoTag) where

>import Useful
>import Pprint
>import Atoms
>import Messages
>import Types

>tag = True
>protoTag = False

>makeResult :: String -> VarTypeList -> String
>makeResult id [] = ""
>makeResult id ((a,b):q)=if (id==a) then 
>		(if (b=="Nonce") then "writeObject(nonceFromId(\""++a++"\"));\n" 
>		else if (b=="Agent") then --"agentFromId(\""++a++"\").setSocket(null);\n"++
>		"writeObject(nameFromId(\""++a++"\"));\n" 
>		else if (b=="BigInteger") then "writeObject("++a++".toString());\n"
>		else if ((drop ((length b)-3) b)=="Key") then "writeObject("++a++".getString());\n"
>		else "") else
>	(makeResult id q)

>makeRun :: String -> VarTypeList -> FnTypeList -> ProtDesc -> [String]-> String
>makeRun id fvts fnts [] comms = ""
>makeRun id fvts fnts (t:q) comms = (makeMsg id fvts fnts t comms) ++ "\n" ++ (makeRun id fvts fnts q comms)

>makeMsg :: String -> VarTypeList -> FnTypeList -> ProtMsgDesc -> [String] -> String
>makeMsg id fvts fnts (assList,num,Agent a,Agent b,msg,_) comms = 
>	let rg=(rang num comms) in
>	if (a==id) then 
>		(makeAsss assList)++
>		"println(\"Building message m"++num++"\");\n"++
>		"Message m"++num++" =message();\n"++
>		(buildMsg num msg fvts fnts)++
>		"println(\"Sending message m"++num++"\");\n"++
>		"put(\""++b++"\", m"++num++".getString()"++
>		(if rg>=0 then ","++show (4000+rg) else "")++");\n" 
>		else "println(\"waiting for m"++num++"\");\n"++
>		"Message m"++num++" = message(get(\""++a++"\""++
>		(if rg>=0 then ","++show (4000+rg) else "")++"));\n"++
>		(match0 num msg fvts fnts)
>makeMsg id fvts fnts (assList,num,Agent a,_,msg,_) comms = 
>	if (a==id) then (makeAsss assList)++(buildOutput num msg fvts fnts) else ""

>buildOutput :: String -> Msg -> VarTypeList -> FnTypeList -> String
>buildOutput nb (Atom s) fvts fnts = makeResult s fvts
>buildOutput nb (Sq []) fvts fnts = ""
>buildOutput nb (Sq (t:q)) fvts fnts = (buildOutput nb t fvts fnts)++(buildOutput nb (Sq q) fvts fnts)

>makeAsss :: [(String, String)] -> String
>makeAsss [] = ""
>makeAsss ((v,s):q) = v++"="++s++";\n"++(makeAsss q)

>buildMsg :: String -> Msg -> VarTypeList -> FnTypeList -> String
>buildMsg nb (Atom s) fvts fnts = "m"++nb++".addMessage(message("++(typed s fvts)++"));\n"
>buildMsg nb (Sq []) fvts fnts = ""
>buildMsg nb (Sq ((Atom s):q)) fvts fnts = (buildMsg nb (Atom s) fvts fnts)++(buildMsg nb (Sq q) fvts fnts)
>buildMsg nb (Sq (t:q)) fvts fnts = (if nb=="0" then "storeM0();\n" else "m0=message();\n")++
>	(buildMsg "0" t fvts fnts)++
>	(if nb=="0" then "m"++nb++"=message(restoreM0(),m0);\n" 
>		else "m"++nb++".addMessage(m0);\n")++
>	(buildMsg nb (Sq q) fvts fnts)
>buildMsg nb (Encrypt key msg) fvts fnts = (if (length(msg)==1) then (buildMsg nb (head msg) fvts fnts) 
>								else (buildMsg nb (Sq msg) fvts fnts))++
>	"println(\"Encrypting m"++nb++"\");\n"++
>	"m"++nb++".encrypt("++(buildKey True key fnts fvts)++(if protoTag==True then ",protoTag" else "")++");\n"
>buildMsg nb (Apply "addr" (Atom a)) fvts fnts = "m"++nb++".setStringAddr(IPFromId(\""++a++ "\"));\n"
>buildMsg nb (Apply f m) fvts fnts = if (drop 3 (fntype f fnts) == "HashFunction") then
>	(buildMsg nb m fvts fnts)++
>	"println(\"Hashing m"++nb++"\");\n"++
>	"m"++nb++".hash(\""++ take 3 (fntype f fnts) ++"\""++(if protoTag==True then ",protoTag" else "")++");\n" 
>	else"ERROR: "++(fntype f fnts)
>buildMsg nb (Xor a b) fvts fnts =
>	(buildMsg nb (Sq [a,b]) fvts fnts)++
>	"println(\"XOR-ing\");\n"++
>	"m"++nb++".xor();\n"
>buildMsg nb (Undec m s) fvts fnts = buildMsg nb m fvts fnts
>buildMsg nb (Forwd s m) fvts fnts = "m"++nb++".addMessage("++s++");\n"
>buildMsg _ _ _ _ = ""

>buildTag :: Msg -> VarTypeList -> FnTypeList -> String
>buildTag (Encrypt (Apply key _) msg) fvts fnts = (if ((fntype key fnts) == "RSAPublicKey") then "P" else
>	if ((fntype key fnts) == "RSASecretKey") then "S" else
>	if ((fntype key fnts) == "DESKey") then "K" else "") ++
>	(buildTag (Sq msg) fvts fnts)++")"
>buildTag (Encrypt (Atom key) msg) fvts fnts =(if (typeOf key fvts)=="DESKey" then "K" else "")++
>	(buildTag (Sq msg) fvts fnts)++")"
>buildTag (Atom s) fvts fnts = if (typeOf s fvts)=="Nonce" then "N" else
>			       if (typeOf s fvts)=="Agent" then "A" else
>			       if (typeOf s fvts)=="DESKey" then "K" else ""
>buildTag (Sq []) fvts fnts = ""
>buildTag (Sq (t:q)) fvts fnts = (buildTag t fvts fnts) ++ (buildTag (Sq q) fvts fnts)
>buildTag (Forwd s m) fvts fnts = buildTag m fvts fnts
>buildTag (Apply "addr" (Atom a)) fvts fnts = "D"
>buildTag (Xor a b) fvts fnts = "X"++(buildTag a fvts fnts) ++ "+"++(buildTag b fvts fnts)++")"
>buildTag (Apply f m) fvts fnts = if (drop 3 (fntype f fnts) == "HashFunction") then
>	"H" else ""
>buildTag (Undec m s) fvts fnts = buildTag m fvts fnts

>match0 :: String -> Msg -> VarTypeList -> FnTypeList -> String
>match0 nb m v f=(if tag==True then "checkTag(m"++nb++",\""++(buildTag m v f)++"\");\n" else "")++
>	(match nb m v f)

>match :: String -> Msg -> VarTypeList -> FnTypeList -> String
>match nb (Encrypt key msg) fvts fnts = "println(\"Decrypting m"++nb++"\");\n"++
>	"m"++nb++".decrypt("++(buildKey False key fnts fvts)++(if protoTag==True then ",protoTag" else "")++");\n"++
>	(match0 nb (Sq msg) fvts fnts)
>match nb (Sq []) fvts fnts = ""
>match nb (Sq l) fvts fnts = "addParts(m"++nb++".getAllFields(),"++(show (length l))++");\n"++
>	(matchList nb l fvts fnts)++
>	"\n"
>match nb (Atom s) fvts fnts = matchAtom nb s fvts
>match nb (Apply "addr" (Atom a)) fvts fnts = "setIPToId(m"++nb++".getString(),\""++a++"\");\n"
>match nb (Apply f m) fvts fnts = if (drop 3 (fntype f fnts) == "HashFunction") then
>	"/* Hash matching*/\n{"++
>	"println(\"Building message mhash\");\n"++
>		(if (nb=="0") then ("storeM0();\n") else "")++
>		"Message mhash = message();\n"++
>		(buildMsg "hash" m fvts fnts)++
>		(if (nb=="0") then ("m0=restoreM0();\n") else "")++
>	"mhash.hash(\""++ (take 3 (fntype f fnts)) ++"\""++(if protoTag==True then ",protoTag" else "")++");\nif (m"++nb++".equals(mhash)) println(\"hash is correct !\");\n"++
>	"else throw new Exception(\"Incorrect hash in message m"++nb++"!\"+m0.getString()+\" \"+mhash.getString());\n}"
>	else ""
>match nb (Xor (Atom a) (Atom b)) fvts fnts =
>	"/* XOR matching*/\n"++
>	"matchXor(m"++nb++",\""++a++"\",\""++b++"\");\n"
>match nb (Undec m s) fvts fnts = "Message "++s++"=message(m"++nb++".getString());\n"
>match nb (Forwd s m) fvts fnts = match nb m fvts fnts
>match _ _ _ _ = ""

>matchAtom :: String -> String -> VarTypeList -> String
>matchAtom nb s [] = ""
>matchAtom nb s ((a,b):q) = if (a==s) then 
>	(if b=="Agent" then (matchAgent nb s) 
>	else if b=="Nonce" then (matchNonce nb s) 
>	else if b=="DESKey" then (matchKey nb s) 
>	else if b=="BigInteger" then (matchInteger nb s)
>	else "") 
>	else (matchAtom nb s q)

>matchAgent :: String -> String -> String
>matchAgent nb s = "setNameToId(m"++nb++".getString(),\""++s++"\");\n"

>matchKey :: String -> String -> String
>matchKey nb s = s++"= messageKey(m"++nb++");\n"

>matchNonce :: String -> String -> String
>matchNonce nb s = "setValueToNonce(m"++nb++".getString(),\""++s++"\");\n"

>matchInteger :: String -> String -> String
>matchInteger nb s = s++" = new BigInteger(m"++nb++".getString());\n"

>matchList :: String -> [Msg] -> VarTypeList -> FnTypeList -> String
>matchList nb [] fvts fnts = ""
>matchList nb (t:q) fvts fnts = "m0=getPart();\n"++(match "0" t fvts fnts)++
>	(matchList nb q fvts fnts)

>typed :: String -> VarTypeList -> String
>typed s [] = s
>typed s ((a,b):q) = if (s==a && b=="DESKey") then s++".getString()" else
>		     if (s==a && b=="Agent") then "agentFromId(\""++s++"\")" else
>		     if (s==a && b=="Nonce") then "nonceFromId(\""++s++"\")" else
>		     if (s==a && b=="BigInteger") then s++".toString()" else
>		     (typed s q)

>buildKey :: Bool -> Msg -> FnTypeList -> VarTypeList -> String
>buildKey sender (Apply name (Atom who)) ((t1,(Defed _ "RSAPublicKey")):q) v = if (name==t1) then 
>	"\"RSA\", "++(if sender then "getPublicKey" else "getPrivateKey")++"(nameFromId(\""++who++"\"))" 
>	else (buildKey sender (Apply name (Atom who)) q v)
>buildKey sender (Apply name (Atom who)) ((t1,(Defed _ "RSASecretKey")):q) v = if (name==t1) then 
>	"\"RSA\", "++(if sender then "getPrivateKey" else "getPublicKey")++"(nameFromId(\""++who++"\"))" 
>	else (buildKey sender (Apply name (Atom who)) q v)
>buildKey sender (Apply name (Atom who)) ((t1,(Defed _ "DESKey")):q) v = if (name==t1) then 
>	"\"DES\", getSecretKey(nameFromId(\""++who++"\"))" 
>	else (buildKey sender (Apply name (Atom who)) q v)
>buildKey sender (Apply name (Atom who)) ((t1,_):q) v = if (name==t1) then "" 
>	else (buildKey sender (Apply name (Atom who)) q v)
>buildKey _ (Atom name) _ v = if (typeOf name v)=="DESKey" then "\"DES\", "++name++".toKey()" else
>	if (typeOf name v)=="BigInteger" then "\"DES\", generateKey("++name++".toByteArray())" else ""
>buildKey _ _ _ _ = ""

>fntype :: String -> FnTypeList -> String
>fntype s [] = ""
>fntype s ((a,(Defed _ b)):q) = if (s==a) then b else
>		      (fntype s q)
>fntype s ((a,HashFunction str):q) = if (s==a) then str++"HashFunction" else
>		      (fntype s q)

>createNodes :: VarTypeList -> String -> ProcessList -> String
>createNodes fvts id [] = ""
>createNodes fvts id ((a,b,c,d,e):q) = if (a==id) then (createNodes2 fvts e) else (createNodes fvts id q)

>createNodes2 :: VarTypeList -> [String] -> String
>createNodes2 fvts [] = ""
>createNodes2 fvts (t:q) = (if ((typeOf t fvts)=="Nonce") then 
>		"println(\"creating nonce "++t++"\");\n"++
>		"createNewNonce(\""++t++"\");\n" else if ((typeOf t fvts)=="DESKey") then
>		"println(\"creating DESkey "++t++"\");\n"++
>		t++" = messageKey(\"DES\");\n" else if ((typeOf t fvts)=="BigInteger") then
>		t++"=freshBI();\n" else "")++
>		(createNodes2 fvts q)

>typeOf :: String -> VarTypeList -> String
>typeOf s [] = s
>typeOf s ((a,b):q) = if (s==a) then b else (typeOf s q)

>rang :: String -> [String] -> Integer
>rang s [] = -1000
>rang s (t:q) = if s==t then 0 else 1+(rang s q)


