package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITSTS extends Protocol {
   
   public INITSTS (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         BigInteger g = null;
         BigInteger m = null;
         BigInteger x = null;
         BigInteger y = null;
         BigInteger gEx = null;
         BigInteger gEy = null;
         BigInteger k = null;
         
         g=freshBI();
         m=freshBI();
         x=freshBI();
         
         gEx=g.modPow(x,m);
         println("Building message m1");
         Message m1 =message();
         m1.addMessage(message(g.toString()));
         m1.addMessage(message(m.toString()));
         m1.addMessage(message(gEx.toString()));
         println("Sending message m1");
         put("B", m1.getString(),4000);
         
         println("waiting for m2");
         Message m2 = message(get("B"));
         gEy = new BigInteger(m2.getString());
         
         k=gEy.modPow(x,m);
         println("Building message m2b");
         Message m2b =message();
         m2b.addMessage(message(agentFromId("A")));
         println("Sending message m2b");
         put("B", m2b.getString());
         
         println("waiting for m2c");
         Message m2c = message(get("B"));
         println("Decrypting m2c");
         m2c.decrypt("DES", generateKey(k.toByteArray()));
         addParts(m2c.getAllFields(),1);
         m0=getPart();
         println("Decrypting m0");
         m0.decrypt("RSA", getPublicKey(nameFromId("B")));
         addParts(m0.getAllFields(),2);
         m0=getPart();
         gEy = new BigInteger(m0.getString());
         m0=getPart();
         gEx = new BigInteger(m0.getString());
         
         
         
         println("Building message m3");
         Message m3 =message();
         m3.addMessage(message(gEx.toString()));
         m3.addMessage(message(gEy.toString()));
         println("Encrypting m3");
         m3.encrypt("RSA", getPrivateKey(nameFromId("A")));
         println("Encrypting m3");
         m3.encrypt("DES", generateKey(k.toByteArray()));
         println("Sending message m3");
         put("B", m3.getString());
         
         writeObject(nameFromId("B"));
         writeObject(k.toString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITSTS A = new INITSTS(oos);
      args=A.getArgs(args);
      A.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 5) {
            args = (String[]) Array.newInstance("".getClass(), 5);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the KeyStore file to use  [keystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="keystore";
            println("Type the password to access it [duitama]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="duitama";
            println("Type the DNS name of agent B [localhost]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="localhost";
            println("Type the name of agent A [A]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="A";
            println("Type the name of agent B [B]");
            args[4]=in2.readLine();
            if (args[4].compareTo("")==0) args[4]="B";
            }
         setKS(args[0],args[1]);
         setIPToId(args[2],"B");
         setNameToId(args[3],"A");
         setNameToId(args[4],"B");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITSTS",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }