package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class RESPSTS extends Protocol {
   
   public RESPSTS (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         BigInteger g = null;
         BigInteger m = null;
         BigInteger x = null;
         BigInteger y = null;
         BigInteger gEx = null;
         BigInteger gEy = null;
         BigInteger k = null;
         
         y=freshBI();
         
         println("waiting for m1");
         Message m1 = message(get("A",4000));
         addParts(m1.getAllFields(),3);
         m0=getPart();
         g = new BigInteger(m0.getString());
         m0=getPart();
         m = new BigInteger(m0.getString());
         m0=getPart();
         gEx = new BigInteger(m0.getString());
         
         
         k=gEx.modPow(y,m);
         gEy=g.modPow(y,m);
         println("Building message m2");
         Message m2 =message();
         m2.addMessage(message(gEy.toString()));
         println("Sending message m2");
         put("A", m2.getString());
         
         println("waiting for m2b");
         Message m2b = message(get("A"));
         setNameToId(m2b.getString(),"A");
         
         println("Building message m2c");
         Message m2c =message();
         m2c.addMessage(message(gEy.toString()));
         m2c.addMessage(message(gEx.toString()));
         println("Encrypting m2c");
         m2c.encrypt("RSA", getPrivateKey(nameFromId("B")));
         println("Encrypting m2c");
         m2c.encrypt("DES", generateKey(k.toByteArray()));
         println("Sending message m2c");
         put("A", m2c.getString());
         
         println("waiting for m3");
         Message m3 = message(get("A"));
         println("Decrypting m3");
         m3.decrypt("DES", generateKey(k.toByteArray()));
         addParts(m3.getAllFields(),1);
         m0=getPart();
         println("Decrypting m0");
         m0.decrypt("RSA", getPublicKey(nameFromId("A")));
         addParts(m0.getAllFields(),2);
         m0=getPart();
         gEx = new BigInteger(m0.getString());
         m0=getPart();
         gEy = new BigInteger(m0.getString());
         
         
         
         writeObject(nameFromId("A"));
         writeObject(k.toString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      RESPSTS B;
      while (true) {
         B=new RESPSTS(oos);
         args=B.getArgs(args);
         B.newAgent("A",4000);
         B.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 3) {
            args = (String[]) Array.newInstance("".getClass(), 3);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the KeyStore file to use  [keystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="keystore";
            println("Type the password to access it [duitama]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="duitama";
            println("Type the name of agent B [B]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="B";
            }
         setKS(args[0],args[1]);
         setNameToId(args[2],"B");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("RESPSTS",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }