package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class RESPYAHA extends Protocol {
   
   public RESPYAHA (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         IMessageKey kab = null;
         
         println("creating nonce nb");
         createNewNonce("nb");
         
         println("waiting for m1");
         Message m1 = message(get("a",4000));
         addParts(m1.getAllFields(),2);
         m0=getPart();
         setNameToId(m0.getString(),"a");
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         
         
         println("Building message m2");
         Message m2 =message();
         m2.addMessage(message(agentFromId("b")));
         m0=message();
         m0.addMessage(message(agentFromId("a")));
         storeM0();
         m0.setStringAddr(IPFromId("a"));
         m0=message(restoreM0(),m0);
         m0.addMessage(message(nonceFromId("na")));
         m0.addMessage(message(nonceFromId("nb")));
         println("Encrypting m0");
         m0.encrypt("DES", getSecretKey(nameFromId("b")));
         m2.addMessage(m0);
         println("Sending message m2");
         put("s", m2.getString(),4001);
         
         println("waiting for m3b");
         Message m3b = message(get("s"));
         println("Decrypting m3b");
         m3b.decrypt("DES", getSecretKey(nameFromId("b")));
         addParts(m3b.getAllFields(),2);
         m0=getPart();
         setNameToId(m0.getString(),"a");
         m0=getPart();
         kab= messageKey(m0);
         
         
         println("waiting for m4");
         Message m4 = message(get("a"));
         println("Decrypting m4");
         m4.decrypt("DES", kab.toKey());
         addParts(m4.getAllFields(),1);
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         writeObject(nameFromId("a"));
         writeObject(kab.getString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      RESPYAHA b;
      while (true) {
         b=new RESPYAHA(oos);
         args=b.getArgs(args);
         b.newAgent("a",4000);
         b.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 4) {
            args = (String[]) Array.newInstance("".getClass(), 4);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the SecretKeyStore file to use [secretkeystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="secretkeystore";
            println("Type the DNS name of agent s [localhost]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="localhost";
            println("Type the name of agent b [b]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="b";
            println("Type the name of agent s [s]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="s";
            }
         setSKS(args[0]);
         setIPToId(args[1],"s");
         setNameToId(args[2],"b");
         setNameToId(args[3],"s");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("RESPYAHA",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }